/*********************************************
Project : TP3 PARABOLE: 
Version : 2
Date    : 29/12/2004
Modif : 05/08
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN
       
Comments: Calcul et affichage de la
vitesse angulaire de la parabole sur un LCD
Entre: signal TTL issu d'un GBF; cbl sur INT de la carte SSI 

Chip type           : ATMEGA8535
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <mega8535.h>
#include <stdlib.h>  // fontion ftoa
#include <delay.h>
#include <ssi.h>   // fonction affiche_LCD
#include <stdio.h> // fonction printf
#include <string.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

// Declare your global variables here
unsigned int teta_n=0;


// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
teta_n = teta_n + 1;
}


void main(void)
{
// Declare your local variables here
unsigned int teta_n_1=0, n;
float omega_A;
char ligne1[17];
char omegA[17]="0.0";

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x03;
MCUCSR=0x00;
GIFR=0x40;

// Configuration du PORTB
// DDRB =           

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")

sprintf(ligne1,"Vit. angl. %c/mn",0xdf); 
delay_ms(2000);                           

while (1)
      {
      if (teta_n < teta_n_1) 			// Dbut traitement 
      	n = (65536 - teta_n_1) + teta_n;
      		else n = teta_n - teta_n_1;
      teta_n_1 = teta_n;                        // sauvegarde de teta_n pour le prochain calcul
      omega_A = 4.77*n;      
      ftoa(omega_A,1,omegA);                    // ftoa convertit l'entier Omega_A en un rel avec un chiffre aprs la virgule
      Affiche_LCD(ligne1,omegA);               // Fin traitement
      delay_ms(2000);
      };
}
